// filesystem_storage_plugin.hpp
//
// Copyright (C) 2006 Visual Media FX Ltd.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#ifndef FILESYSTEM_STORAGE_PLUGIN_INC_
#define FILESYSTEM_STORAGE_PLUGIN_INC_

#include <openpluginlib/pl/string.hpp>
#include <openassetlib/plugins/filesystem_storage_plugin/config.hpp>
#include <openassetlib/al/al_plugin.hpp>
#include <openassetlib/al/set.hpp>

namespace opl = olib::openpluginlib;

namespace olib { namespace openassetlib { namespace plugins { namespace filesystem {

class AL_FILESYSTEM_DECLSPEC filesystem_storage_plugin : public al::al_plugin
{
public:
	filesystem_storage_plugin(void);
	virtual ~filesystem_storage_plugin(void);

	al::set_ptr	store(const al::set_ptr& set);
	al::set_ptr	load(const opl::string& query_xml);			// <filesystem_query searchfolder="c:\Media\Images" recurse="TRUE" filenameregex=".*\.png">
															//     <filesize comparitor=">=">10000000</filesize>
															//     <lastmodified comparitor=">">
															//         <year>2005</year>
															//         <month>1</month>
															//         <day>1</day>
															//         <hour>0</hour>
															//         <minute>0</minute>
															//         <second>0</second>
															//     </lastmodified>
															// </filesystem_query>
};

} } } }

#endif
