// query.hpp
//
// Copyright (C) 2006 Visual Media FX Ltd.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#ifndef QUERY_INC_
#define QUERY_INC_

#include <boost/filesystem/operations.hpp>
#include <openassetlib/al/set.hpp>

namespace fs  = boost::filesystem;
namespace oal = olib::openassetlib;

namespace olib { namespace openassetlib { namespace plugins { namespace filesystem {

class query
{
public:
	query(const fs::path& root_folder, const opl::string& filename_regex, bool recurse);
	query(const fs::path& root_folder, const opl::string& filename_regex, bool recurse, const opl::string& filesize_comparitor, long long comparison_filesize);
	query(const fs::path& root_folder, const opl::string& filename_regex, bool recurse, const opl::string& datetime_comparitor, const std::tm& comparison_datetime);
	query(const fs::path& root_folder, const opl::string& filename_regex, bool recurse, const opl::string& filesize_comparitor, long long comparison_filesize, const opl::string& datetime_comparitor, const std::tm& comparison_datetime);
	~query(void);

	al::set_ptr run();

private:
	bool			search(const fs::path& directory, al::set_ptr set);

	// data extracted from xml
	bool			recurse_;
	fs::path		root_folder_;
	opl::string		filename_regex_;
	boost::intmax_t	comparison_filesize_;
	opl::string		filesize_comparitor_;
	std::tm			comparison_datetime_;
	opl::string		datetime_comparitor_;
};

} } } }

#endif
