
// X3DBZ - An X3D (bzip2 compressed) plugin to sg.

// Copyright (C) 2005 Visual Media FX Ltd.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#include <boost/thread/recursive_mutex.hpp>

#include <openobjectlib/plugins/x3dbz/x3dbz_plugin.hpp>

namespace opl   = olib::openpluginlib;
namespace X3DBZ = olib::openobjectlib::plugins::X3DBZ;

namespace
{
	void reflib( int init )
	{
		static long refs = 0;
	
		assert( refs >= 0 && L"X3DBZ_plugin::refinit: refs is negative." );
		
		if( init > 0 && ++refs )
		{
		}
		else if( init < 0 && --refs == 0 )
		{
		}
	}
}

extern "C"
{
	X3DBZ_DECLSPEC bool openplugin_init( void )
	{
		boost::recursive_mutex mutex;
		
		reflib( 1 );
		
		return true;
	}

	X3DBZ_DECLSPEC bool openplugin_uninit( void )
	{
		boost::recursive_mutex mutex;

		reflib( -1 );
		
		return true;
	}

	X3DBZ_DECLSPEC bool openplugin_create_plugin( const char*, opl::openplugin** plug )
	{
		*plug = new X3DBZ::X3DBZ_plugin;
		
		return true;
	}
	
	X3DBZ_DECLSPEC void openplugin_destroy_plugin( opl::openplugin* plug )
	{ delete static_cast<X3DBZ::X3DBZ_plugin*>( plug ); }
}
