
// openpluginlib - A plugin interface to openlibraries.

// Copyright (C) 2005-2006 Visual Media FX Ltd.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#include <openpluginlib/pl/property.hpp>
#include <openpluginlib/py/python.hpp>
#include <openpluginlib/py/py.hpp>

namespace opl	= olib::openpluginlib;
namespace py	= boost::python;

namespace olib { namespace openpluginlib { namespace detail {

void py_multi_property( )
{	
#define DEFINE_OPL_MULTI_PROPERTY( type, name )									\
	opl::type::iterator ( opl::type::*begin_##type )( ) = &opl::type::begin;	\
	opl::type::iterator ( opl::type::*end_##type )( ) = &opl::type::end;		\
	py::class_<opl::type>( name )												\
		.def( "__iter__", py::range( begin_##type, end_##type ) )				\
		.def( "empty", &opl::type::empty )										\
		.def( "size", &opl::type::size )										\
		.def( "clear", &opl::type::clear )										\
		.def( "push_back", &opl::type::push_back )								\
		.def( "resize", &opl::type::resize )									\
		.def( "reserve", &opl::type::reserve )									\
		;

	DEFINE_OPL_MULTI_PROPERTY( m_bool, "m_bool" )
	DEFINE_OPL_MULTI_PROPERTY( m_color, "m_color" )
	DEFINE_OPL_MULTI_PROPERTY( m_color_rgba, "m_color_rgba" )
	DEFINE_OPL_MULTI_PROPERTY( m_float, "m_float" )
	DEFINE_OPL_MULTI_PROPERTY( m_double, "m_double" )
	DEFINE_OPL_MULTI_PROPERTY( m_int32, "m_int32" )
	DEFINE_OPL_MULTI_PROPERTY( m_matrix4d, "m_matrix4d" )
	DEFINE_OPL_MULTI_PROPERTY( m_matrix4f, "m_matrix4f" )
	DEFINE_OPL_MULTI_PROPERTY( m_rotation, "m_rotation" )
	DEFINE_OPL_MULTI_PROPERTY( m_string, "m_string" )
#if defined ( HAVE_BOOST_FILESYSTEM )
	DEFINE_OPL_MULTI_PROPERTY( m_url, "m_url" )
#endif
	DEFINE_OPL_MULTI_PROPERTY( m_vec2d, "m_vec2d" )
	DEFINE_OPL_MULTI_PROPERTY( m_vec2f, "m_vec2f" )
	DEFINE_OPL_MULTI_PROPERTY( m_vec3d, "m_vec3d" )
	DEFINE_OPL_MULTI_PROPERTY( m_vec3f, "m_vec3f" )
	DEFINE_OPL_MULTI_PROPERTY( m_vec4d, "m_vec4d" )
	DEFINE_OPL_MULTI_PROPERTY( m_vec4f, "m_vec4f" )

#undef DEFINE_OPL_MULTI_PROPERTY
}

} } }
