
// openpluginlib - A plugin interface to openlibraries.

// Copyright (C) 2005-2006 Visual Media FX Ltd.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#include <openpluginlib/pl/string.hpp>
#include <openpluginlib/pl/pcos/property_container.hpp>
#include <openpluginlib/pl/pcos/property.hpp>
#include <openpluginlib/pl/pcos/subject.hpp>
#include <openpluginlib/pl/pcos/key.hpp>
#include <openpluginlib/py/python.hpp>
#include <openpluginlib/py/py.hpp>

namespace pcos	= olib::openpluginlib::pcos;
namespace py	= boost::python;

namespace olib { namespace openpluginlib { namespace detail {

class property_container_wrapper : public pcos::property_container
{
public:
    pcos::property getPropertyWithString( const char* k ) const
    {
        return getProperty( k );
    }

    pcos::property getPropertyWithKey( const pcos::key& k ) const
    {
        return getProperty( k );
    }
};

void py_pcos_property_container()
{
    py::class_< pcos::property_container, py::bases< pcos::subject > >( "__property_container", py::no_init )
        .def( "getKeys", &pcos::property_container::getKeys )
        .def( "append", &pcos::property_container::append )
        .def( "remove", &pcos::property_container::remove );

    py::class_< property_container_wrapper, py::bases< pcos::property_container > >( "property_container" )
        .def( "getProperty", &property_container_wrapper::getPropertyWithString, py::return_value_policy< py::return_by_value >() )
        .def( "getProperty", &property_container_wrapper::getPropertyWithKey, py::return_value_policy< py::return_by_value >() );

    py::implicitly_convertible< property_container_wrapper, pcos::property_container >();
}

} } }
