
// openpluginlib - A plugin interface to openlibraries.

// Copyright (C) 2005-2006 Visual Media FX Ltd.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#include <openpluginlib/pl/pcos/observer.hpp>
#include <openpluginlib/pl/pcos/subject.hpp>
#include <openpluginlib/py/python.hpp>
#include <openpluginlib/py/py.hpp>
#include <boost/utility.hpp>
#include <boost/shared_ptr.hpp>

namespace pcos	= olib::openpluginlib::pcos;
namespace py	= boost::python;

namespace olib { namespace openpluginlib { namespace detail {

void py_pcos_subject()
{
    py::class_< pcos::subject, boost::shared_ptr< pcos::subject >, boost::noncopyable >( "subject" )
        .def( "attach", &pcos::subject::attach )
        .def( "detach", &pcos::subject::detach )
        .def( "update", &pcos::subject::update )
        .def( "block", &pcos::subject::block )
        .def( "unblock", &pcos::subject::unblock );
}

} } }
